using System;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
using BinTreeCanvasLib;
// Select a project node in Solution Explorer, 
// and then, on the Project BinTreeTest, click Properties. When the Project Designer appears, click the Application tab.
// click the Application tab.
// Startup object: You also have to define a public 
// static void Main() method in a class in the project. 
// This class will appear in the Startup object list as 2 classes:
// BinTreeTest.Program
// BinTreeTest.Program0
// You can then select the class as the startup object. 

namespace BinTreeTest
{
    class Program
    {
        
        static void Main(string[] args)
        {
            Stack<int> st = new Stack<int>();
            st.Push(7);
            st.Push(9);
            st.Push(4);
            st.Push(8);
            BinTreeNode<Stack<int>> bt = new BinTreeNode<Stack<int>>(st);
            TreeCanvas.AddTree(bt);
            Console.ReadKey();
            st = new Stack<int>();
            st.Push(2);
            st.Push(1);
            st.Push(8);
            st.Push(1);
            bt.SetRight(new BinTreeNode<Stack<int>>(st));
            TreeCanvas.AddTree(bt);
            Console.ReadKey();
            BinTreeNode<Stack<int>> bt1 = bt.GetRight();
            st = new Stack<int>();
            st.Push(1);
            st.Push(3);
            bt1.SetLeft(new BinTreeNode<Stack<int>>(st));
            TreeCanvas.AddTree(bt);
            Console.ReadKey();
            st = new Stack<int>();
            bt1.SetRight(new BinTreeNode<Stack<int>>(st));
            TreeCanvas.AddTree(bt);
            Console.ReadKey();
            st = new Stack<int>();
            st.Push(1);
            st.Push(4);
            st.Push(9);
            st.Push(2);
            bt1 = bt1.GetRight();
            bt1.SetLeft(new BinTreeNode<Stack<int>>(st));
            TreeCanvas.AddTree(bt);
            Console.ReadKey();
            st = TreeStackSum(bt);
            Console.WriteLine("Returned Stack: " + st);
            Console.ReadKey();
            Console.WriteLine("Tree after colling TreeStackSum");
            TreeCanvas.AddTree(bt);
            Console.ReadKey();
            TreeCanvas.PrintOutAllElements(true);
            TreeCanvas.SetAnimastion(AnimationSpeed.StopAfterAllSteps);
            TreeCanvas.TreeDrawInOrder();

        }
        public static Stack<int> TreeStackSum(BinTreeNode<Stack<int>> bt)
        {
            if (bt == null)
            
                return new Stack<int>();
            
            Stack<int> tmp = new Stack<int>();
            Stack<int> stL;
            Stack<int> stR; 
            stL = TreeStackSum(bt.GetLeft());
            stR = TreeStackSum(bt.GetRight());
            stL.Push(SumOfThree(bt.GetInfo()));
            while (!stR.IsEmpty())
                tmp.Push(stR.Pop());
            while (!tmp.IsEmpty())
                stL.Push(tmp.Pop());
            return stL;

        }
        public static int SumOfThree(Stack<int> st)
        {
            Stack<int> tmp = new Stack<int>();
            int sum = 0, n = 0;
            while (!st.IsEmpty() && n < 3)
            {
                tmp.Push(st.Pop());
                sum += tmp.Top();
                n++;
            }
            for (int i = 1; i <= n; i++)
                st.Push(tmp.Pop());
            return sum;
        }
    } 
}
