using System;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
using BinTreeCanvasLib;
// Select a project node in Solution Explorer, 
// and then, on the Project BinTreeTest, click Properties. When the Project Designer appears, click the Application tab.
// click the Application tab.
// Startup object: You also have to define a public 
// static void Main() method in a class in the project. 
// This class will appear in the Startup object list as 2 classes:
// BinTreeTest.Program
// BinTreeTest.Program0
// You can then select the class as the startup object. 

namespace BinTreeTest
{
    class Program0
    {
        
        static void Main(string[] args)
        {
            
            BinTreeNode<int> t;
            t = BinTreeUtils.BuildRandomTree(40, 1, 19);
            TreeCanvas.AddTree(t);
            Console.ReadLine();
            TreeCanvas.TreeDrawInOrder();
            Console.ReadLine();
            TreeCanvas.PrintOutAllElements(true);        
            TreeCanvas.TreeDrawPostOrder();
            Console.ReadLine();
            TreeCanvas.SetAnimastion(AnimationSpeed.StopAfterAllSteps);
            TreeCanvas.TreeDrawLevelOrder();
            
            
        }
    } 
}
